/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { Number_$type, typeCast, runOn, markType, markDep, getEnumerator, Point_$type, fromEnum } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { Flattener } from "igniteui-react-core";
/**
 * @hidden
 */
var BollingerBandsOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsOverlay, _super);
    function BollingerBandsOverlay() {
        var _this = _super.call(this) || this;
        _this.yd = 0;
        _this.ye = 0;
        _this.yb = new List$1(Number_$type, 0);
        _this.yc = new List$1(Number_$type, 0);
        _this.ab = BollingerBandsOverlay.$;
        _this.uf = new CategoryFrame(4);
        _this.uh = new CategoryFrame(4);
        _this.ud = new CategoryFrame(4);
        return _this;
    }
    BollingerBandsOverlay.prototype.bc = function () {
        return new BollingerBandsOverlay();
    };
    BollingerBandsOverlay.prototype.pa = function (a, b, c, d) {
        if (this.vu().contains(b)) {
            this.x5 = false;
        }
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case BollingerBandsOverlay.$$p[1]:
                this.x5 = false;
                this.pr(false);
                break;
            case BollingerBandsOverlay.$$p[0]:
                this.pr(false);
                break;
        }
    };
    BollingerBandsOverlay.prototype.x6 = function () {
        this.yb.clear();
        this.yc.clear();
        var a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.vt), this.yg));
        var b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.vt), this.yg));
        this.ye = 1.7976931348623157E+308;
        this.yd = -1.7976931348623157E+308;
        var c = true;
        var d = true;
        var e = this.yf;
        while (c || d) {
            if (a.moveNext()) {
                this.yb.add(a.current);
            }
            else {
                c = false;
            }
            if (b.moveNext()) {
                this.yc.add(b.current);
            }
            else {
                d = false;
            }
            if (c && d) {
                this.ye = Math.min(this.ye, a.current - b.current * e);
                this.yd = Math.max(this.yd, a.current + b.current * e);
            }
        }
        return true;
    };
    BollingerBandsOverlay.prototype.aq = function (a) {
        if (this.yb == null || this.yc == null || a == null || this.c7 == null || a != this.uu) {
            return null;
        }
        var b = new AxisRange(this.ye, this.yd);
        return b;
    };
    BollingerBandsOverlay.prototype.xh = function (a, b) {
        _super.prototype.xh.call(this, a, b);
        var c = b.by;
        var d = b.bx;
        var e = this.getEffectiveViewport1(b);
        var f = this.ub;
        var g = this.uu;
        var h = new ScalerParams(0, c, d, f.ch, e);
        var i = new ScalerParams(0, c, d, g.ch, e);
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = typeCast(ISortingAxis_$type, this.ub);
        if (j != null && j.i$b.count != this.c7.count) {
            return;
        }
        var k = 0;
        k = this.v2(c, d, e);
        if (!this.x5) {
            this.x5 = this.x6();
            if (this.uu != null) {
                this.uu.c2(true);
            }
        }
        i.b = this.h3();
        var l = this.ub.em(2, h) - this.ub.em(1, h);
        for (var m = b.b0.c; m <= b.b0.d; ++m) {
            var n = void 0;
            if (j == null) {
                n = b.b0.getBucket(m);
            }
            else {
                var o = j.i$b._inner[m];
                var p = j.i$d(o);
                var q = this.yb._inner[m];
                var r = this.yc._inner[m];
                var s = q;
                var t = r;
                var u = p;
                var v = 1;
                while (m < b.b0.d) {
                    o = j.i$b._inner[m + 1];
                    u = j.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s += this.yb._inner[m];
                    t += this.yc._inner[m];
                    v++;
                }
                s /= v;
                t /= v;
                var w = s - t * this.yf;
                var x = s;
                var y = s + t * this.yf;
                var z = NaN;
                if (!isNaN_(p)) {
                    z = this.ub.ej(p, h);
                }
                n = [z, w, x, y];
            }
            var aa = Math.max(1, l);
            if (!isNaN_(n[0]) && m * aa >= this.x7) {
                if (this.ub != null && typeCast(ISortingAxis_$type, this.ub) !== null) {
                    n[0] = n[0] + k;
                }
                else {
                    n[0] = f.ej(n[0], h) + k;
                }
                n[1] = g.ej(n[1], i);
                n[2] = g.ej(n[2], i);
                n[3] = g.ej(n[3], i);
                a.f.add(n);
            }
        }
    };
    BollingerBandsOverlay.prototype.nk = function (a, b) {
        _super.prototype.nk.call(this, a, b);
        var c = b;
        if (c != null) {
            c.b7();
        }
    };
    BollingerBandsOverlay.prototype.ia = function (a, b, c) {
        if (this.yb == null) {
            return _super.prototype.ia.call(this, a, b, c);
        }
        var d = this.getEffectiveViewport1(this.cg);
        var e = this.v2(this.cg.by, this.cg.bx, d);
        var f = new ScalerParams(0, this.cg.by, this.cg.bx, this.ub.ch, d);
        f.c = this.cv.t6;
        return this.ic(this.yb, a, this.ub, f, e, runOn(this, this.v1), b, c);
    };
    BollingerBandsOverlay.prototype.jg = function (a, b) {
        if (this.yb == null) {
            return _super.prototype.jg.call(this, a, b);
        }
        return this.jh(a, b, this.ub, runOn(this, this.v1), this.yb);
    };
    BollingerBandsOverlay.prototype.je = function (a, b) {
        if (this.yb == null) {
            return _super.prototype.je.call(this, a, b);
        }
        return this.jf(a, b, this.ub, runOn(this, this.v1), this.yb);
    };
    BollingerBandsOverlay.prototype.gm = function (a, b, c) {
        var d = _super.prototype.gm.call(this, a, b, c);
        if (!this.vk(this.vu())) {
            d = false;
        }
        return d;
    };
    BollingerBandsOverlay.prototype.xj = function (a, b) {
        _super.prototype.xj.call(this, a, b);
        var c = typeCast(BollingerBandsOverlayView.$, b);
        var d = this.getEffectiveViewport1(b);
        if (b.b3(a)) {
            c.b7();
            var e_1 = a.f.count;
            var f = function (g) { return a.f._inner[g][0]; };
            var g = function (h) { return a.f._inner[e_1 - 1 - h][0]; };
            var h = function (i) { return a.f._inner[i][1]; };
            var i = function (j) { return a.f._inner[j][2]; };
            var j = function (k) { return a.f._inner[e_1 - 1 - k][3]; };
            c.b8(e_1, f, g, h, i, j);
            b.b5(a);
        }
        this.uk.a2(this, this.vj(), runOn(this, this.t3), this.v8(b), this.wa(b));
        var k = false;
        var l = this.uk.b;
        var m = a.f;
        var n = this.c7.count;
        if (l != null) {
            k = true;
        }
        if (k) {
            var o = new ScalerParams(0, b.by, b.bx, this.ub.ch, d);
            this.xg(m, -1, n, this.ub, o, b.q);
        }
        var p = c.cf;
        var q = c.cg;
        var r = c.ch;
        var s = c.ca;
        this.uk.ad(q, true, false, true, true);
        this.uk.an = null;
        this.uk.am = null;
        this.uk.ad(p, true, false, false, true);
        this.uk.ad(r, true, false, false, true);
        this.uk.ad(s, false, true, false, false);
        s._opacity = this.uk.j * this.hg;
    };
    BollingerBandsOverlay.prototype.cd = function () {
        return new BollingerBandsOverlayView(this);
    };
    BollingerBandsOverlay.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.ya = typeCast(BollingerBandsOverlayView.$, a);
    };
    BollingerBandsOverlay.prototype.wb = function () {
        return 3;
    };
    BollingerBandsOverlay.prototype.h3 = function () {
        return Series.h5(this.yb, null);
    };
    BollingerBandsOverlay.$t = markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
    BollingerBandsOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:yf:yj', [1, 2], 'Period:yg:yk', [1, 14]]);
    return BollingerBandsOverlay;
}(FinancialOverlay));
export { BollingerBandsOverlay };
/**
 * @hidden
 */
var BollingerBandsBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsBucketCalculator, _super);
    function BollingerBandsBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    BollingerBandsBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.a.b2.c7.count - 1);
        if (b <= c) {
            var d = this.f.b6.yf;
            var e = 0;
            var f = 0;
            var g = 0;
            for (var h = b; h <= c; ++h) {
                if (!isNaN_(this.f.b6.yb._inner[h]) && !isNaN_(this.f.b6.yc._inner[h])) {
                    e += this.f.b6.yb._inner[h];
                    f += this.f.b6.yc._inner[h];
                    ++g;
                }
            }
            if (g > 0) {
                e = e / g;
                f = f / g;
                return [0.5 * (b + c), e - f * d, e, e + f * d];
            }
        }
        return [NaN, NaN, NaN, NaN];
    };
    BollingerBandsBucketCalculator.$t = markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
    return BollingerBandsBucketCalculator;
}(FinancialBucketCalculator));
export { BollingerBandsBucketCalculator };
/**
 * @hidden
 */
var BollingerBandsOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsOverlayView, _super);
    function BollingerBandsOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.b6 = null;
        _this.cb = new Polygon();
        _this.ci = new Polyline();
        _this.cj = new Polyline();
        _this.ck = new Polyline();
        _this.b9 = new Polygon();
        _this.cc = new Polyline();
        _this.cd = new Polyline();
        _this.ce = new Polyline();
        _this.b6 = a;
        return _this;
    }
    BollingerBandsOverlayView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
        }
    };
    BollingerBandsOverlayView.prototype.b1 = function () {
        return new BollingerBandsBucketCalculator(this);
    };
    BollingerBandsOverlayView.prototype.b8 = function (a, b, c, d, e, f) {
        var e_2, _a, e_3, _b, e_4, _c;
        try {
            for (var _d = __values(fromEnum(Flattener.d(a, b, d, this.e.hk))), _e = _d.next(); !_e.done; _e = _d.next()) {
                var g = _e.value;
                this.cb.an.add({ $type: Point_$type, x: b(g), y: d(g) });
                this.ci.an.add({ $type: Point_$type, x: b(g), y: d(g) });
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return))
                    _a.call(_d);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        try {
            for (var _f = __values(fromEnum(Flattener.d(a, b, e, this.e.hk))), _g = _f.next(); !_g.done; _g = _f.next()) {
                var h = _g.value;
                this.cj.an.add({ $type: Point_$type, x: b(h), y: e(h) });
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return))
                    _b.call(_f);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        try {
            for (var _h = __values(fromEnum(Flattener.d(a, c, f, this.e.hk))), _j = _h.next(); !_j.done; _j = _h.next()) {
                var i = _j.value;
                this.cb.an.add({ $type: Point_$type, x: c(i), y: f(i) });
                this.ck.an.add({ $type: Point_$type, x: c(i), y: f(i) });
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_j && !_j.done && (_c = _h.return))
                    _c.call(_h);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.as();
    };
    BollingerBandsOverlayView.prototype.b7 = function () {
        this.cb.an.clear();
        this.ci.an.clear();
        this.cj.an.clear();
        this.ck.an.clear();
        this.as();
    };
    Object.defineProperty(BollingerBandsOverlayView.prototype, "ca", {
        get: function () {
            return this.cb;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "cf", {
        get: function () {
            return this.ci;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "cg", {
        get: function () {
            return this.cj;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "ch", {
        get: function () {
            return this.ck;
        },
        enumerable: false,
        configurable: true
    });
    BollingerBandsOverlayView.prototype.be = function () {
        _super.prototype.be.call(this);
        this.b9.an = this.cb.an;
        this.cc.an = this.ci.an;
        this.cd.an = this.cj.an;
        this.ce.an = this.ck.an;
        var a = this.br();
        this.b9._fill = a;
        this.b9._opacity = 1;
        this.cc._stroke = a;
        this.cc.ad = this.e.hl + 3;
        this.cd._stroke = a;
        this.cd.ad = this.e.hl + 3;
        this.ce._stroke = a;
        this.ce.ad = this.e.hl + 3;
    };
    BollingerBandsOverlayView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (a.d) {
            if (b) {
                a.u(this.b9);
                a.v(this.cc);
                a.v(this.cd);
                a.v(this.ce);
            }
            else {
                a.u(this.cb);
                a.v(this.ci);
                a.v(this.cj);
                a.v(this.ck);
            }
        }
    };
    BollingerBandsOverlayView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        this.e.a5.exportPolygonData(a, this.cb, "FillShape", ["Fill"]);
        this.e.a5.exportPolylineData(a, this.ci, "BottomLine", ["Lower", "Main"]);
        this.e.a5.exportPolylineData(a, this.cj, "CentralLine", ["Central"]);
        this.e.a5.exportPolylineData(a, this.ck, "TopLine", ["Upper"]);
    };
    BollingerBandsOverlayView.$t = markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
    return BollingerBandsOverlayView;
}(FinancialSeriesView));
export { BollingerBandsOverlayView };
